#ifndef Scenerunner_h
#define Scenerunner_h

#include "Arduino.h" 
#include <LiquidCrystal.h>
#include <BasicStepperDriver.h>

class Scenerunner {

  public:
    // configuration values
    int tSettle = 1000;
    int tFocus = 1000;
    int tShutter = 1000;
    bool bReturn = true;
    bool bDarkenLcd = true;

    // scene values
    int nSteps = 10;
    float distance = 0.5;

    Scenerunner(LiquidCrystal *lcd, BasicStepperDriver *stepper, int pin_focus, int pin_shutter);
    void start();
    void nextAction();

  private:
    LiquidCrystal *_lcd;
    BasicStepperDriver *_stepper;
    int _pin_focus;
    int _pin_shutter;

    int steps_left;
    enum RunStep { RUN_OFF, RUN_SETTLE, RUN_FOCUS, RUN_SHUTTER, RUN_MOVE, RUN_RETURN };
    RunStep runStep = RUN_OFF;
    unsigned long int runStepStart;

};

#endif
